/*******************************************************************************
*   $FILE:  QDebugTransport.h
*   Atmel Corporation:  http://www.atmel.com \n
*   xEҰ:  touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

#ifndef DEBUGTRANSPORT_H_INCLUDED
#define DEBUGTRANSPORT_H_INCLUDED

/*----------------------------------------------------------------------------
qɂꂽݸٰ ̧
----------------------------------------------------------------------------*/
#include "touch_api.h"

/*----------------------------------------------------------------------------
ϸ
----------------------------------------------------------------------------*/
#define MESSAGE_START	0x1B
#define INT(a, b)		((a << 8) | b)
#define STATE_IDLE		0
#define STATE_LENGTH1	1
#define STATE_LENGTH2	2
#define STATE_DATA		3

#ifdef _ROTOR_SLIDER_
  #ifdef _OPT_SRAM_
	#define TX_BUFFER_SIZE	1
  #else
	#define TX_BUFFER_SIZE	(QT_NUM_CHANNELS*4)+10
  #endif
	#define RX_BUFFER_SIZE	(QT_NUM_CHANNELS*4)+10
#else
  #ifdef _OPT_SRAM_
	#define TX_BUFFER_SIZE	1
  #else
	#define TX_BUFFER_SIZE	(QT_NUM_CHANNELS*3)+10
  #endif
	#define RX_BUFFER_SIZE	(QT_NUM_CHANNELS*3)+10
#endif

/*----------------------------------------------------------------------------
Oϐ
----------------------------------------------------------------------------*/
extern uint8_t TX_Buffer[TX_BUFFER_SIZE];
extern uint16_t TX_index;
extern uint8_t RX_Buffer[RX_BUFFER_SIZE];
extern uint16_t RX_index;
extern uint8_t packet_crc;
extern uint8_t SequenceL;
extern uint8_t SequenceH;
extern unsigned int gMsTimeout;

/*----------------------------------------------------------------------------
^
----------------------------------------------------------------------------*/
void Init_Buffers (void);
void Set_datamode (unsigned char mode);

// M֐
void PutChar (uint8_t data);
void PutInt (uint16_t data);
uint8_t GetChar (void);
void Send_Message (void);

// M֐
uint8_t Receive_Message (void);
uint8_t RxHandler (uint8_t c);

#endif
/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-EOF-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
