/*
 * \file
 *
 * \brief
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef TWI_MASTER_H_INCLUDED
#define TWI_MASTER_H_INCLUDED

/*============================ ϸ ===========================================*/
#define TWISLAVE_ADDR		0x10

/*============================ Sϐ ======================================*/
union TWI_statusReg					// ׸ނێ޲
{
	unsigned char all;
	struct
	{
		unsigned char lastTransOK:1;
		unsigned char unusedBits:7;
	};
};

extern volatile union TWI_statusReg TWI_statusReg;

/*============================ ^ ==========================================*/
void TWI_Master_Init (void);
unsigned char TWI_Transceiver_Busy (void);
void TWI_Send_Message (void);
void TWI_Retrieve_Message (void);

/*============================ ޯĂ޲Ă̒` ==============================*/
#define TWI_READ_BIT	0		// "ڽ ޲"R/WޯĂޯĈʒu
#define TWI_ADR_BITS	1		// Jn޲ē̏]uڽ ޯĂLSBޯĈʒu

#define TRUE			1
#define FALSE			0

/*============================ TWIԕ ===================================*/
// STWI呕uԕ
#define TWI_START					0x08	// Jno
#define TWI_REP_START				0x10	// đJno
#define TWI_ARB_LOST				0x38	// r(s)

// TWI呕uMԕ
#define TWI_MTX_ADR_ACK				0x18	// SLA+WM,ACKM
#define TWI_MTX_ADR_NACK			0x20	// SLA+WM,NACKM
#define TWI_MTX_DATA_ACK			0x28	// ް ޲đM,ACKM
#define TWI_MTX_DATA_NACK			0x30	// ް ޲đM,NACKM

// TWI呕uMԕ
#define TWI_MRX_ADR_ACK				0x40	// SLA+RM,ACKM
#define TWI_MRX_ADR_NACK			0x48	// SLA+RM,NACKM
#define TWI_MRX_DATA_ACK			0x50	// ް ޲ĎM,ACK
#define TWI_MRX_DATA_NACK			0x58	// ް ޲ĎM,NACK

// TWI]uMԕ
#define TWI_STX_ADR_ACK				0xA8	// SLA+RM,ACK
#define TWI_STX_ADR_ACK_M_ARB_LOST	0xB0	// 呕uƂSLA+R/WŒs,SLA+RM,ACK
#define TWI_STX_DATA_ACK			0xB8	// ް ޲đM,ACKM
#define TWI_STX_DATA_NACK			0xC0	// ް ޲đM,NACKM
#define TWI_STX_DATA_ACK_LAST_BYTE	0xC8	// ŏIް ޲đM(TWEA=0),ACKM

// TWI]uMԕ
#define TWI_SRX_ADR_ACK				0x60	// SLA+WM,ACK
#define TWI_SRX_ADR_ACK_M_ARB_LOST	0x68	// 呕uƂSLA+R/WŒs,SLA+WM,ACK
#define TWI_SRX_GEN_ACK				0x70	// ČĂяoM,ACK
#define TWI_SRX_GEN_ACK_M_ARB_LOST	0x78	// 呕uƂSLA+R/WŒs,ČĂяoM,ACK
#define TWI_SRX_ADR_DATA_ACK		0x80	// ڽwԂްM,ACK
#define TWI_SRX_ADR_DATA_NACK		0x88	// ڽwԂްM,NACK
#define TWI_SRX_GEN_DATA_ACK		0x90	// ČĂяoްM,ACK
#define TWI_SRX_GEN_DATA_NACK		0x98	// ČĂяoްM,NACK
#define TWI_SRX_STOP_RESTART		0xA0	// ڽwԒɒ~܂͍đJno

// TWȊԕ
#define TWI_NO_STATE				0xF8	// ֘Aԏ񗘗ps(TWINT)
#define TWI_BUS_ERROR				0x00	// s@ȊJn܂͒~̂߂޽ُ

#define TWI_GEN_CALL				0x00	// ČĂяoڽ0

#endif
/* EOF */
