/*******************************************************************************
*   $FILE:  TWI_Master.c
*   Atmel Corporation	: http://www.atmel.com \n
*   xE-Ұ			: touch@atmel.com
******************************************************************************/

/* 
* 쌠 (c) 2010, Atmel Corporation S\ς݁B
*
* ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
* ΋܂B
*
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
* 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
* ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
* fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
* RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 Ȃł傤B
*/

/*============================ ݸٰ =======================================*/
#include "touch.h"

#if defined(_DEBUG_INTERFACE_) && defined(QDEBUG_TWI)
#include <avr/io.h>
#include <avr/interrupt.h>
#include "TWI_Master.h"
#include "QDebugTransport.h"

/*============================ Ǐϐ ======================================*/
static volatile unsigned char TWI_addr;				// MɏՕ
static volatile unsigned int TWI_msgSize;			// M޲Đ

volatile union TWI_statusReg TWI_statusReg = {0};	// TWI_statusRegTWI_Master.hŒ`܂B

/*============================ Sϐ ======================================*/
unsigned int gMsTimeout;
#define NOT_TIMEDOUT()			(gMsTimeout)
#define SET_TIMEOUT(timeout)	(gMsTimeout = timeout)

/*============================================================================
O: TWI_Master_Init
------------------------------------------------------------------------------
ړI: TWI
: Ȃ
o: Ȃ
: QDebug.cQDebug_InitĂ΂܂B
============================================================================*/
void TWI_Master_Init (void)
{
	// ײނQT600-TINY88-QT8pɕύXĂ܂B
	// ʂtinyAVRmegaAVRɂײނgpꍇALڍ\ݒ͕ύXׂ܂B

	TWHSR = 0;									// Wgp:Fscl=110kHz
	TWSR = 	0;									// Ou1ɐݒ
	TWBR = 10;									// ޯđxFscl=100kHz/220kHz
	TWDR = 0xFF;								// e=SDAJ
	TWCR = (1<<TWEN)|							// TWI̪ATWI݊J
		   (0<<TWIE)|(0<<TWINT)|				// TWI荞݋֎~
		   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// M}vȂ
		   (0<<TWWC);							//
}

/*============================================================================
O: TWI_Transceiver_Busy
------------------------------------------------------------------------------
ړI: TWI_ISRMZ
: Ȃ
o: TWIMZ̏ꍇTrueԂB
: TWIM֐Ă΂܂B
============================================================================*/
unsigned char TWI_Transceiver_Busy (void)
{
	// TWI荞݂ȂAM͑Z
	return ( TWCR & (1<<TWIE) );
}

/*============================================================================
O: TWI_Send_Message
------------------------------------------------------------------------------
ړI: TX_BufferɊi[ꂽڰтUSBدނ֑o
: Ȃ
o: Ȃ
: QDebugTransport.cSend_MessageĂ΂܂B
============================================================================*/
void TWI_Send_Message (void)
{
	SET_TIMEOUT(10);							// 10msԐݒ
	TWI_msgSize = ((TX_Buffer[1]<<8)+TX_Buffer[2]);
	TWI_addr  =(TWISLAVE_ADDR<<TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);
	TWI_statusReg.all = 0;
	TWCR = (1<<TWEN)|							// TWI̪
		   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋A׸މ
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|		// JnJn
		   (0<<TWWC);

		   while (TWI_Transceiver_Busy()&& NOT_TIMEDOUT());		// TWȊM܂őҋ@
}

/*============================================================================
O: TWI_Send_Message
------------------------------------------------------------------------------
ړI: USBدނ1ڰтǂŁAڰтRX_BufferɊi[
: Ȃ
o: Ȃ
: QDebugTransport.cReceive_MessageĂ΂܂B
============================================================================*/
void TWI_Retrieve_Message (void)
{
	unsigned int i;

	SET_TIMEOUT(10);							// 10msԐݒ

	TWI_addr  = (TWISLAVE_ADDR<<TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);

	TWI_statusReg.all = 0;

	TWCR = (1<<TWEN)|							// TWI̪
		   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋A׸މ
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|		// JnJn
		   (0<<TWWC);							//

	while (TWI_Transceiver_Busy()&& NOT_TIMEDOUT());	// TWȊM܂őҋ@

	if( ! TWI_statusReg.lastTransOK )			// Ō̑MɊŁA
		for ( i=0; i<=TWI_msgSize; i++ )		// MɏՕް𕡎
			RX_Buffer[i] = 0;					// Ms̏ꍇް
}

/*============================================================================
O: TWI_ISR
------------------------------------------------------------------------------
ړI: ̊֐͊荞ݏٰ(ISR:Interrupt Service Routine)ŁATWI荞
	  N鎞Ă΂܂B
: Ȃ
o: Ȃ
: TWIۂN鎞ɎIɎs܂B
============================================================================*/

ISR(TWI_vect)
{
	static unsigned int TWI_bufPtr;
	volatile unsigned char FrameInProgress;

	switch (TWSR)
	{
		case TWI_START:				// Jno
		case TWI_REP_START:			// đJno
			TWI_bufPtr = 0;			// ɏՕʒuwqTWIڽʒuɐݒ
			TWDR = TWI_addr;
			TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			break;

		case TWI_MTX_ADR_ACK:		// SLA+WMAACKM
		case TWI_MTX_DATA_ACK:		// ް ޲đMAACKM
			if (TWI_bufPtr <= TWI_msgSize)
			{
				TWDR = TX_Buffer[TWI_bufPtr++];
				TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			}
			else					// ŏI޲Čɒ~o
			{
				TWI_statusReg.lastTransOK = TRUE;		// ޯĂ𐬌ɐݒ
				TWCR = (1<<TWEN)|(0<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|(0<<TWWC);
			}
			break;

		case TWI_MRX_ADR_ACK:		// SLA+RMAACKM
			TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			break;

		case TWI_MRX_DATA_ACK:		// ް ޲ĎMAACKM
			FrameInProgress=RxHandler(TWDR);
			if (FrameInProgress )	// NACKŏI޲Ăo
			{
				// MACKo
				TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			}
			else
			{
//				TWI_Protocol_State=TWI_STATE_MSG_START;	// TWIVK߹ĎM
				// MNACKo
				TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			}
			break;

		case TWI_MRX_DATA_NACK:		// ް ޲ĎMANACKM
			RxHandler(TWDR);
			TWI_statusReg.lastTransOK = TRUE;			// ޯĂ𐬌ɐݒ
			// ~Jn
			TWCR = (1<<TWEN)|(0<<TWIE)|(1<<TWINT)|(0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|(0<<TWWC);
			break;

		case TWI_ARB_LOST:			// s
			// (đ)JnJn
			TWCR = (1<<TWEN)|(1<<TWIE)|(1<<TWINT)|(0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|(0<<TWWC);
			break;

		case TWI_MTX_ADR_NACK:		// SLA+WMANACKM
		case TWI_MRX_ADR_NACK:		// SLA+RMANACKM
		case TWI_MTX_DATA_NACK:		// ް ޲đMANACKM
//		case TWI_NO_STATE			// p\Ȋ֘AԏȂ(`TWINT)
		case TWI_BUS_ERROR:			// sȊJn܂͒~̂߂޽ُ
		default:
														// TWI̪ ؾ
			TWCR = (1<<TWEN)|							// TWI̪ATWI݊J
				   (0<<TWIE)|(0<<TWINT)|				// TWI荞݋֎~
				   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// }MvȂ
				   (0<<TWWC);							//
	}
}
#endif /* _DEBUG_INTERFACE_ */
