/*******************************************************************************
*   $FILE:  qt_asm_tiny_mega.S
*   Atmel Corporation	: http://www.atmel.com
*   xE-Ұ			: touch@atmel.com
******************************************************************************/

/*  
* 쌠 (c) 2010, Atmel Corporation S\ς݁B
*
* ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
* ΋܂B
*
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	 Ȃ΂Ȃ܂B
*
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	 ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
* 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	 (ۏ)ɎgpłȂ܂B
*
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
* ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
* fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
* RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
* Ȃł傤B
*/

#include "qt_asm_avr.h"

FILE_HEADER

FILE_SEGMENT

#if (_POWER_OPTIMIZATION_ == 1)
#if defined(__IAR_SYSTEMS_ASM__)
EXPORT temp1
EXPORT temp2
temp1 GLOBAL_VAR 0
temp2 GLOBAL_VAR 0
#else
.global temp1
.global temp2
.EQU temp1,0
.EQU temp2,0
#endif
#endif

#if (_STATIC_PORT_PIN_CONF_ == 0)

GLOBAL_FUNCTION _0111010111_
_0111010111_:
	PUSH R19
	PUSH R25
	IN   R19, REG( DDR, SNS1 )
	MOV  R25, p_1
	COM  R25
	AND  R19, R25
	OUT  REG( DDR, SNS1 ), R19
	IN   R19, REG( DDR, SNSK1 )
	AND  R19, R25
	OUT  REG( DDR, SNSK1 ), R19
	IN   R19, REG( PORT, SNS1 )
#if (_POWER_OPTIMIZATION_ == 1)
	STS  temp1, R19
#endif
	OR   R19, p_1
	OUT  REG( PORT, SNS1 ), R19
	IN   R19, REG( PORT, SNSK1 )
	AND  R19, R25
	OUT  REG( PORT, SNSK1 ), R19
	IN   R19, REG( DDR, SNSK1 )
	OR   R19, p_1
	OUT  REG( DDR, SNSK1 ), R19
#if (_POWER_OPTIMIZATION_ == 1)
	STS  temp2, R19
#endif
	POP  R25
	POP  R19
	RET

#if (_POWER_OPTIMIZATION_ == 0)
GLOBAL_FUNCTION _01001010111_
_01001010111_:
	PUSH R19
	PUSH R23
	PUSH R25
	IN   R23, REG( DDR, SNSK1 )
	MOV  R25, p_1
	COM  R25
	AND  R23, R25
	OUT  REG( DDR, SNSK1 ), R23
	IN   R19, REG( DDR, SNS1 )
	OR   R19, p_1
	AND  R25, R19
	OR   R23, p_1
	OUT  REG( DDR, SNS1 ), R19
#if (QT_DELAY_CYCLES == 1)
#elif (QT_DELAY_CYCLES == 2)
	_00011001_
#elif (QT_DELAY_CYCLES == 3)
	_00011001_
	_00011001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 0)
	_11100011_
	_10100011_
	_01101001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 1)
	_11100011_
	_10100011_
	_01101001_
	_00011001_
#else
	_11100011_
	_10100011_
	_01101001_
	_00011001_
	_00011001_
#endif
	OUT  REG( DDR, SNS1 ), R25
	OUT  REG( DDR, SNSK1 ), R23
	POP  R25
	IN   r_v, REG( PIN, SNS1 )
	AND  r_v, p_2
	POP  R23
	POP  R19
	RET

#else

GLOBAL_FUNCTION _01001010111_
_01001010111_:
	OUT  REG( DDR, SNSK1 ), p_4
	OUT  REG( DDR, SNS1 ), p_1
#if (QT_DELAY_CYCLES == 1)
#elif (QT_DELAY_CYCLES == 2)
	_00011001_
#elif (QT_DELAY_CYCLES == 3)
	_00011001_
	_00011001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 0)
	_11100011_
	_10100011_
	_01101001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 1)
	_11100011_
	_10100011_
	_01101001_
	_00011001_
#else
	_11100011_
	_10100011_
	_01101001_
	_00011001_
	_00011001_
#endif
	OUT  REG( DDR, SNS1 ), p_2
	OUT  REG( DDR, SNSK1 ), p_3
	NOP
	IN   r_v, REG( PIN, SNS1 )
	AND  r_v, p_5
	RET

#endif

GLOBAL_FUNCTION _0101110111_
_0101110111_:
	PUSH R19
	PUSH R25
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( PORT, SNS1 )
	AND  R19, R25
	OUT  REG( PORT, SNS1 ), R19
	IN   R19, REG( DDR, SNS1 )
	OR   R19, p_1
	OUT  REG( DDR, SNS1 ), R19
	POP  R25
	POP  R19
	RET

#endif
///////////////////////////////////////////////////////

#if ((_STATIC_PORT_PIN_CONF_ == 1) && (QTOUCH_SNS_PORT_COUNT >= 1))

GLOBAL_FUNCTION _1101010101_
_1101010101_:
	PUSH R19
	PUSH R23
	PUSH R25
	MOV  R23, p_2
	COM  R23
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( DDR, SNS1 )
	AND  R19, R25
	OUT  REG( DDR, SNS1 ), R19
#if (_POWER_OPTIMIZATION_ == 1)
	STS  temp1, R19
#endif
	IN   R19, REG( DDR, SNSK1 )
	AND  R19, R23
	OUT  REG( DDR, SNSK1 ), R19
	IN   R19, REG( PORT, SNS1 )
	OR   R19, p_1
	OUT  REG( PORT, SNS1 ), R19
	IN   R19, REG( PORT, SNSK1 )
	AND  R19, R23
	OUT  REG( PORT, SNSK1 ), R19
	IN   R19, REG( DDR, SNSK1 )
#if (_POWER_OPTIMIZATION_ == 1)
	STS  temp1, R19
#endif
	OR   R19, p_2
	OUT  REG( DDR, SNSK1 ), R19
	POP  R25
	POP  R23
	POP  R19
	RET

#if (_POWER_OPTIMIZATION_ == 0)
GLOBAL_FUNCTION _1101010111_
_1101010111_:
	PUSH R19
	PUSH R23
	PUSH R25
	MOV  R23, p_2
	COM  R23
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( DDR, SNSK1 )
	AND  R23, R19
	OUT  REG( DDR, SNSK1 ), R23
	IN   R19, REG( DDR, SNS1 )
	OR   R23, p_2
	OR   R19, p_1
	AND  R25, R19
	OUT  REG( DDR, SNS1 ), R19
#if (QT_DELAY_CYCLES == 1)
#elif (QT_DELAY_CYCLES == 2)
	_00011001_
#elif (QT_DELAY_CYCLES == 3)
	_00011001_
	_00011001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 0)
	_11100011_
	_10100011_
	_01101001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 1)
	_11100011_
	_10100011_
	_01101001_
	_00011001_
#else
	_11100011_
	_10100011_
	_01101001_
	_00011001_
	_00011001_
#endif
	OUT  REG( DDR, SNS1 ), R25
	OUT  REG( DDR, SNSK1 ), R23
	POP  R25
	IN   r_v, REG( PIN, SNS1 )
	AND  r_v, p_3
	POP  R23
	POP  R19
	RET

#else
GLOBAL_FUNCTION _1101010111_
_1101010111_:
	OUT  REG( DDR, SNSK1 ), p_4
	OUT  REG( DDR, SNS1 ), p_1
#if (QT_DELAY_CYCLES == 1)	
#elif (QT_DELAY_CYCLES == 2)
	_00011001_
#elif (QT_DELAY_CYCLES == 3)
	_00011001_
	_00011001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 0)
	_11100011_
	_10100011_
	_01101001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 1)
	_11100011_
	_10100011_
	_01101001_
	_00011001_
#else
	_11100011_
	_10100011_
	_01101001_
	_00011001_
	_00011001_
#endif
	OUT  REG( DDR, SNS1 ), p_2
	OUT  REG( DDR, SNSK1 ), p_3
	NOP
	IN   r_v, REG( PIN, SNS1 )
	AND  r_v, p_5
	RET
#endif

GLOBAL_FUNCTION _1101010110_
_1101010110_:
	PUSH R19
	PUSH R25
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( PORT, SNS1 )
	AND  R19, R25
	OUT  REG( PORT, SNS1 ), R19
	IN   R19, REG( DDR, SNS1 )
	OR   R19, p_1
	OUT  REG( DDR, SNS1 ), R19
	POP  R25
	POP  R19
	RET

#endif

#if ((_STATIC_PORT_PIN_CONF_ == 1) && (QTOUCH_SNS_PORT_COUNT == 2))

GLOBAL_FUNCTION _1101011111_
_1101011111_:
	PUSH R19
	PUSH R23
	PUSH R25
	MOV  R23, p_2
	COM  R23
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( DDR, SNS2 )
#if (_POWER_OPTIMIZATION_ == 1)
	STS  temp1, R19
#endif
	AND  R19, R25
	OUT  REG( DDR, SNS2 ), R19
	IN   R19, REG( DDR, SNSK2 )
	AND  R19, R23
	OUT  REG( DDR, SNSK2 ), R19
	IN   R19, REG( PORT, SNS2 )
	OR   R19, p_1
	OUT  REG( PORT, SNS2 ), R19
	IN   R19, REG( PORT, SNSK2 )
	AND  R19, R23
	OUT  REG( PORT, SNSK2 ), R19
	IN   R19, REG( DDR, SNSK2 )
#if (_POWER_OPTIMIZATION_ == 1)
	STS  temp1, R19
#endif
	OR   R19, p_2
	OUT  REG( DDR, SNSK2 ), R19
	POP  R25
	POP  R23
	POP  R19
	RET

#if (_POWER_OPTIMIZATION_ == 0)
GLOBAL_FUNCTION _1101011110_
_1101011110_:
	PUSH R19
	PUSH R23
	PUSH R25
	MOV  R23, p_2
	COM  R23
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( DDR, SNSK2 )
	AND  R23, R19
	OUT  REG( DDR, SNSK2 ), R23
	IN   R19, REG( DDR, SNS2 )
	OR   R23, p_2
	OR   R19, p_1
	AND  R25, R19
	OUT  REG( DDR, SNS2 ), R19
#if (QT_DELAY_CYCLES == 1)
#elif (QT_DELAY_CYCLES == 2)
	_00011001_
#elif (QT_DELAY_CYCLES == 3)
	_00011001_
	_00011001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 0)
	_11100011_
	_10100111_
	_01101011_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 1)
	_11100011_
	_10100111_
	_01101011_
	_00011001_
#else
	_11100011_
	_10100111_
	_01101011_
	_00011001_
	_00011001_
#endif
	OUT  REG( DDR, SNS2 ), R25
	OUT  REG( DDR, SNSK2 ), R23
	POP  R25
	IN   r_v, REG( PIN, SNS2 )
	AND  r_v, p_3
	POP  R23
	POP  R19
	RET

#else

GLOBAL_FUNCTION _1101011110_
_1101011110_:
	OUT  REG( DDR, SNSK2 ), p_4
	OUT  REG( DDR, SNS2 ), p_1
#if (QT_DELAY_CYCLES == 1)
#elif (QT_DELAY_CYCLES == 2)
	_00011001_
#elif (QT_DELAY_CYCLES == 3)
	_00011001_
	_00011001_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 0)
	_11100011_
	_10100111_
	_01101011_
#elif ((QT_DELAY_CYCLES - 1) - (3 * ((QT_DELAY_CYCLES - 1)/3)) == 1)
	_11100011_
	_10100111_
	_01101011_
	_00011001_
#else
	_11100011_
	_10100111_
	_01101011_
	_00011001_
	_00011001_
#endif
	OUT  REG( DDR, SNS2 ), p_2
	OUT  REG( DDR, SNSK2 ), p_3
	NOP
	IN   r_v, REG( PIN, SNS2 )
	AND  r_v, p_5
	RET

#endif

GLOBAL_FUNCTION _1101011010_
_1101011010_:
	PUSH R19
	PUSH R25
	MOV  R25, p_1
	COM  R25
	IN   R19, REG( PORT, SNS2 )
	AND  R19, R25
	OUT  REG( PORT, SNS2 ), R19
	IN   R19, REG( DDR, SNS2 )
	OR   R19, p_1
	OUT  REG( DDR, SNS2 ), R19
	POP  R25
	POP  R19
	RET

#endif

FILE_FOOTER
