/*******************************************************************************
*   $FILE:  main.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

/*----------------------------------------------------------------------------
								  ߲׏
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								 ݸٰ ̧
----------------------------------------------------------------------------*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include "touch.h"
/*----------------------------------------------------------------------------
								  Ȓ萔
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									^`
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ^
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								  \̐錾
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ϸ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								   Sϐ
----------------------------------------------------------------------------*/
/* msł̌v */
extern uint16_t qt_measurement_period_msec;
extern uint16_t time_ms_inc;
/*----------------------------------------------------------------------------
								   Oϐ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								   ÓIϐ
----------------------------------------------------------------------------*/

/* ڐG̎Ԃ̎ɌvɂĐݒ肳׸ */
extern volatile uint8_t time_to_measure_touch;

/* vISRɂĐݒ肳錻݂̎ */
extern volatile uint16_t current_time_ms_touch;

#if defined (__ATmega324PA__)
#if defined(_QTOUCH_)
/*============================================================================
O: init_timer_isr
------------------------------------------------------------------------------
ړI: Iɔ悤ɌvISR`Ԑݒ
============================================================================*/
void init_timer_isr (void)
{
	OCR1A = ( TICKS_PER_MS * qt_measurement_period_msec);	/* vrlݒ(ǂ̈ʂ̕pxŌvISR邩?) */
	TIMSK1 |= (1u << OCIE1A);								/* rAŌvISR */
	TCCR1B |= (1u << CS11);									/* vOu= ۯ/8 */
	TCCR1B |= (1u << WGM12);								/* v퓮`=CTC(rvŌvؾ) */
}

ISR(TIMER1_COMPA_vect)
{
	time_to_measure_touch = 1u;								/* ׸ސݒ:͐ڐG𑪒肷鎞 */
	current_time_ms_touch += qt_measurement_period_msec;	/* ݂̎ԂXV */
}

/*============================================================================
O: set_timer_period
------------------------------------------------------------------------------
ړI: vύX
============================================================================*/
void set_timer_period (uint16_t qt_measurement_period_msec)
{
	OCR1A = ( TICKS_PER_MS * qt_measurement_period_msec);
}

#elif defined (_QMATRIX_)
/*============================================================================
O: init_timer_isr
------------------------------------------------------------------------------
ړI: Iɔ悤ɌvISR`Ԑݒ
============================================================================*/
void init_timer_isr (void)
{
	OCR0A = ( TICKS_PER_MS * 1);			/* vrlݒ(1msv튄荞݂ɐݒ) */
	TIMSK0 |= (1 << OCIE0A);				/* rAvŌvISR */
	TCCR0B |= (1 << CS02) | (1 << CS00);	/* vOu= ۯ/1024 */
	TCCR0A |= ( 1 << WGM01 );				/* v퓮`=CTC(rvŌvؾ) */
}

ISR(TIMER0_COMPA_vect)
{
	time_ms_inc++;

	if(time_ms_inc >= qt_measurement_period_msec)
	{
		time_ms_inc =0;
		time_to_measure_touch = 1u;			/* ׸ސݒ:͐ڐG𑪒肷鎞 */
	}
	else
	{
	}
	current_time_ms_touch++;;				/* ݂̎ԂXV */
}
/*============================================================================
O: set_timer_period
------------------------------------------------------------------------------
ړI: vύX
============================================================================*/
void set_timer_period (uint16_t qt_measurement_period_msec)
{
	OCR0A = ( TICKS_PER_MS * 1);
}
#endif

/*============================================================================
O: init_system
------------------------------------------------------------------------------
ړI: νĉpA݁AޯނȂǏ
============================================================================*/
void init_system (void)
{
	/* 8MHzős */
	asm("ldi r16,0x80");
	asm("sts 0x61,r16");
	asm("ldi r16,0x00");
	asm("sts 0x61,r16");

	/* JTAG݋֎~ */
	asm("ldi r16,0x80");
	asm("sts 0x55,r16");
	asm("ldi r16,0x80");
	asm("sts 0x55,r16");

	asm("nop");
	asm("nop");

	/* Sٱߋ֎~ */
	MCUCR |= (1u << PUD);
}
#endif
